using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Lotosummary.Tabulate
{
    public class FileOutputNewLine : Feedable
    {
        string pathName;
        StringBuilder os;

        public override bool ending(bool csv)
        {
            if (csv)
            {
                for (; ; )
                {
                    os.Append(separator);
                    itemCount += 1;
                    if (itemCount >= FIELD_COUNT)
                    {
                        os.Append(Environment.NewLine);
                        break;
                    }

                }

            }
            else
            {
                os.Append(Environment.NewLine);
            }

            var file = new FileStream(pathName, FileMode.Create);
            string buffer = os.ToString();
            byte[] data = System.Text.Encoding.UTF8.GetBytes(buffer);
            file.Write(data, 0, data.Length);
            file.Close();
            return true;
        }

        public override int writing(string item)
        {
            os.Append(item);
            os.Append(separator);
            size += FIELD_SIZE;
            itemCount += 1;
            if (itemCount >= FIELD_COUNT)
            {
                os.Append(Environment.NewLine);
                size += NEW_LINE_SIZE;
                itemCount = 0;
            }

            return size;
        }

        public FileOutputNewLine(string p)
        {
            pathName = p;
            os = new StringBuilder();
        }

    }

}
