/*
Rannu CS Version 1.05
Producing a random number table
Copyright 2017 Sogaya

Visual C# 2008 Compiler version 3.5
.NET Framework version 3.5
(Visual Studio 2008 Express Edition)

*/

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Lotosummary.Tabulate
{
    class Program
    {   // エンコーディング：UTF-8
        static string[] driveDirectoryBase(string s) 
        {
            const string SLASH = "/";
            const string YEN = "\\";
            string[] UNDIVIDED = {"", "", "", ""};
            int firstTrace, trace, w;
            int s_length = s.Length;
            string c;
            string SEPARATOR = YEN;
            string[] part = {"", "", "", ""};
            part[0] = s; // s.length > 0; in other words, part[0].length > UNDIVIDED[0].length

// s is divided into three parts: drive name, directory name, and base name.
            int k = 0;
            for( ; k < s_length; ++k) 
            {
                c = s.Substring(k, 1);
                if(c == YEN) 
                {
                    SEPARATOR = YEN;
                    break;
                } 
                else if(c == SLASH) 
                {
                    SEPARATOR = SLASH;
                    break;
                }

            }

            if(k == s_length) 
            {
                return UNDIVIDED;
            } 
            else 
            { // SEPARATOR has been found.
                w = k + 1;
                part[1] = s.Substring(0, w); // C:\ for example
                trace = ++k;
                firstTrace = trace;
            }

            for( ; k < s_length; ++k) 
            {
                c = s.Substring(k, 1);
                if(c == SEPARATOR) 
                {
                    trace = ++k;
                }

            }

            w = trace - firstTrace;
            part[2] = s.Substring(firstTrace, w);
            part[3] = s.Substring(trace); // manage.txt for example
            return part;
        }

        static void guide(bool comments) 
        {
            const double VERSION = 1.05;

            if(comments) 
            {
                Console.Error.Write("rannu CS Version ");
                Console.Error.WriteLine(VERSION);
                Console.Error.WriteLine("");
                Console.Error.WriteLine("rannu          # Produce rannu.txt ");
                Console.Error.WriteLine("rannu -6       # Loto-6 ");
                Console.Error.WriteLine("rannu -7       # Loto-7 ");
                Console.Error.WriteLine("rannu -c       # CSV ");
                Console.Error.WriteLine("rannu -f400    # idling ");
                Console.Error.WriteLine("rannu -g       # interval of 0 to 63 ");
                Console.Error.WriteLine("rannu -i1-37   # interval of 1 to 37 ");
                Console.Error.WriteLine("rannu -k32     # 32 kilobytes ");
                Console.Error.WriteLine("rannu -m       # Miniloto ");
                Console.Error.WriteLine("rannu -pm      # MT ");
                Console.Error.WriteLine("rannu -pr      # Ranrot B ");
                Console.Error.WriteLine("rannu -ps      # SFMT ");
                Console.Error.WriteLine("rannu -pw      # Well ");
                Console.Error.WriteLine("rannu -px      # Xorshift ");
                Console.Error.WriteLine("rannu -r       # standard output ");
                Console.Error.WriteLine("rannu -r > file_name # Redirect.");
                Console.Error.WriteLine("rannu -s123456       # seed ");
                Console.Error.WriteLine("rannu -s0      # Time is used as seed. ");
                Console.Error.WriteLine("rannu -V       # version ");
                Console.Error.WriteLine("rannu -VC      # version with comments");
            } 
            else 
            {
                Console.Error.Write("rannu CS Version ");
                Console.Error.WriteLine(VERSION);
                Console.Error.WriteLine("");
                Console.Error.WriteLine("rannu          ");
                Console.Error.WriteLine("rannu -6       ");
                Console.Error.WriteLine("rannu -7       ");
                Console.Error.WriteLine("rannu -c       ");
                Console.Error.WriteLine("rannu -f400    ");
                Console.Error.WriteLine("rannu -g       ");
                Console.Error.WriteLine("rannu -i1-37   ");
                Console.Error.WriteLine("rannu -k32     ");
                Console.Error.WriteLine("rannu -m       ");
                Console.Error.WriteLine("rannu -pm      ");
                Console.Error.WriteLine("rannu -pr      ");
                Console.Error.WriteLine("rannu -ps      ");
                Console.Error.WriteLine("rannu -pw      ");
                Console.Error.WriteLine("rannu -px      ");
                Console.Error.WriteLine("rannu -r       ");
                Console.Error.WriteLine("rannu -r > file_name ");
                Console.Error.WriteLine("rannu -s123456       ");
                Console.Error.WriteLine("rannu -s0      ");
                Console.Error.WriteLine("rannu -V       ");
                Console.Error.WriteLine("rannu -VC      ");
            }

        }

        static void Main(string[] args)
        {
            const bool WITH_COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const int ERROR_CODE = 1;
            const int FROM = 400;
            const int KILOBYTES = 32;
            const int MERSENNE_TWISTER = 1; // MT
            const int SEED = 123456;
            const int RANROT_B = 3;
            const int SFMT_PRNG = 4;
            const int XORSHIFT = 6;
            const string CSV = "-c";
            const string FROM_TERM = "-f";
            const string GROUPING = "-g";
            const string INTERVAL = "-i";
            const string KILOBYTE_TERM = "-k";
            const string LOTO_6 = "-6";
            const string LOTO_7 = "-7";
            const string MANAGE_TEXT = "manage.txt";
            const string MINILOTO = "-m";
            const string PRNG_MT = "-pm";
            const string PRNG_RANROT_B = "-pr";
            const string PRNG_SFMT = "-ps";
            const string PRNG_XORSHIFT = "-px";
            const string REDIRECT = "-r";
            const string SEED_TERM = "-s";
            const string SEPARATOR = "\\";
            const string version_comments = "-VC";
            const string version_guide = "-V";

            bool csv = false;
            bool grouping = false;
            bool produce_rannu_text = true;
            int d;
            int from = FROM;
            int interval_0 = 1;
            int interval_1 = 37;
            int kilo = KILOBYTES;
            int prng = MERSENNE_TWISTER; // MT
            int seed = SEED;
            Numbered n;

            foreach (string s in args)
            {
                switch(s)
                {
                    case CSV:
                        csv = true;
                        break;
                    case GROUPING:
                        grouping = true;
                        break;
                    case LOTO_6:
                        interval_1 = 43;
                        break;
                    case LOTO_7:
                        interval_1 = 37;
                        break;
                    case MINILOTO:
                        interval_1 = 31;
                        break;
                    case PRNG_MT:
                        prng = MERSENNE_TWISTER;
                        break;
                    case PRNG_RANROT_B:
                        prng = RANROT_B;
                        break;
                    case PRNG_SFMT:
                        prng = SFMT_PRNG;
                        break;
                    case PRNG_XORSHIFT:
                        prng = XORSHIFT;
                        break;
                    case REDIRECT:
                        produce_rannu_text = false;
                        break;
                    case version_guide:
                        guide(WITHOUT_COMMENTS);
                        Environment.Exit(ERROR_CODE);
                        break;
                    case version_comments:
                        guide(WITH_COMMENTS);
                        Environment.Exit(ERROR_CODE);
                        break;
                    default:
                        d = s.IndexOf(FROM_TERM);
                        if(d >= 0) 
                        {
                            n = new Numbered(s);
                            from = n.number();
                            if( FROM_TERM == n.parameter() ) 
                            {
                                continue;
                            }

                            from = FROM;
                        }

                        d = s.IndexOf(INTERVAL);
                        if(d >= 0) 
                        {
                            n = new Numbered(s);
                            interval_1 = n.number();
                            if( n.trimmed_sequence() ) 
                            {
                                interval_0 = n.subnumber();
                                if( INTERVAL == n.parameter() ) 
                                {
                                    continue;
                                }

                            }

                            interval_0 = 1;
                            interval_1 = 37;
                        }

                        d = s.IndexOf(KILOBYTE_TERM);
                        if(d >= 0) 
                        {
                            n = new Numbered(s);
                            kilo = n.number();
                            if( KILOBYTE_TERM == n.parameter() ) 
                            {
                                continue;
                            }

                            kilo = KILOBYTES;
                        }

                        d = s.IndexOf(SEED_TERM);
                        if(d >= 0) 
                        {
                            n = new Numbered(s);
                            seed = n.number();
                            if( SEED_TERM == n.parameter() ) 
                            {
                                continue;
                            }

                            seed = SEED;
                        }

                        break;
                } // switch

            } // foreach

            string firstPart = System.IO.Directory.GetCurrentDirectory();
            string fullPathName;
            string[] name = {"", "", "", ""};
            name = driveDirectoryBase(firstPart);
            string root = name[1];
            if (firstPart == root) // C:\ for example
            {
                fullPathName = root + MANAGE_TEXT;
            }
            else // C:\RannuCS for example 
            {
                fullPathName = firstPart + SEPARATOR + MANAGE_TEXT;
            }

            if (System.IO.File.Exists(fullPathName))
            {
                // Producing a random number table
                var rannu = new Rannu();
                rannu.run(from, interval_0,interval_1, kilo, prng, seed, csv, grouping, produce_rannu_text);
                Environment.Exit(0);

            } 
            else 
            {
                // Creating MANAGE_TEXT
                string[] m = {
                    "",           // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
                    "0",          // m[1], csv: RANNU_CSV
                    "C:\\",       // m[2], pathName includes the directory name (C:\) and RANNU_TEXT.
                    "32",         // m[3], kilo: RANNU_TEXT size (kilobytes, KB)
                    "1",          // m[4], interval_0: Loto-7
                    "37",         // m[5], interval_1: Loto-7
                    "0",          // m[6], grouping: interval of 0-63
                    "400",        // m[7], from: idling
                    "123456",     // m[8], seed: pseudorandom number generator (PRNG)
                    "2147483647", // m[9], lineCount: the first part of RANNU_TEXT
                };

                const int MANAGE_TEXT_LINE_COUNT = 9;
                var os = new StringBuilder();
                for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 )
                {
                    os.Append(m[line]);
                    os.Append(Environment.NewLine);
                }

                string buffer = os.ToString();
                var file = new FileStream(fullPathName, FileMode.Create); // MANAGE_TEXT
                byte[] data = System.Text.Encoding.UTF8.GetBytes(buffer);
                file.Write(data, 0, data.Length);
                Environment.Exit(ERROR_CODE);
            }

        }

    }

}
